/* Copyright (c) <2003-2019> <Julio Jerez, Newton Game Dynamics>
* 
* This software is provided 'as-is', without any express or implied
* warranty. In no event will the authors be held liable for any damages
* arising from the use of this software.
* 
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 
* 3. This notice may not be removed or altered from any source distribution.
*/

#ifndef __DGPHYSICS_H__
#define __DGPHYSICS_H__

#include <dg.h>
#include "dgBody.h"
#include "dgWorld.h"
#include "dgContact.h"
#include "dgCollision.h"
#include "dgMeshEffect.h"
#include "dgConstraint.h"
#include "dgDynamicBody.h"
#include "dgWorldPlugins.h"
#include "dgCollisionBVH.h"
#include "dgContactSolver.h"
#include "dgKinematicBody.h"
#include "dgCollisionMesh.h"
#include "dgCollisionScene.h"
#include "dgBodyMasterList.h"
#include "dgUserConstraint.h"
#include "dgBallConstraint.h"
#include "dgHingeConstraint.h"
#include "dgSkeletonContainer.h"
#include "dgCollisionInstance.h"
#include "dgCollisionUserMesh.h"
#include "dgSlidingConstraint.h"
#include "dgUpVectorConstraint.h"
#include "dgCollisionConvexHull.h"
#include "dgUniversalConstraint.h"
#include "dgCorkscrewConstraint.h"
#include "dgBroadPhaseAggregate.h"
#include "dgCollisionHeightField.h"
#include "dgCollisionConvexPolygon.h"
#include "dgCollisionDeformableMesh.h"
#include "dgCollisionCompoundFractured.h"
#include "dgCollisionLumpedMassParticles.h"

#endif 

